const db = require("../services/dbconnection");
const validation = require("../controllers/validation")
const config = require("../configs/config.json");
const moment = require('moment');
const createToken = require("../middlewares/createToken");
const logger=require("../utils/logger");


module.exports.loginUser = async (req, res) => {
    const validationResp = await validation.logindatacheck(req);
    if (validationResp.status) {
        try {
            const query = "select user_id,login_id,first_name,last_name,last_login_date,password from user_master where login_id='" + req.body.username + "' and password='" + req.body.password + "'";
            const result = await db.executequery(query);
            logger.info('log of login api search login user query result', result);

            if (result.length == '0') {
                res.send({
                    status: true,
                    data: [{
                        message: "Invaild User",
                        loginStatus: "1",
                        logindata: {
                            user_id: "",
                            user_name: "",
                            last_loginDate: ""
                        },
                        exception: {
                            errorid: "",
                            errormessage: "No Errors"
                        }
                    }],
                    error: ""

                })
            }
            else {
                var rolData1;
               
             
                const logindate = moment(new Date()).format("YYYY-MM-DD HH:mm");
                const login_id = result[0].login_id;
                const user_id = result[0].user_id;
                const createdtoken = await createToken.createToken(user_id);

                const findRole = "call SP_roleidentify1('" + login_id + "')";
                console.log("findRole", findRole);

                const roleidentify = await db.executequery(findRole);
                rolData = roleidentify[0];

                if (rolData != undefined) {
                    rolData.forEach(function (item) {
                        console.log(item.role_des);
                        rolData1 = item.role_des;
                    });
                    console.log(rolData1);
                }
                //console.log("item",item);
                rol_des = rolData1;
                if(rol_des == undefined){
                    rol_des="";
                }
                console.log("rol_des",rol_des);
                const query = "update user_master SET last_login_date='" + logindate + "' where  login_id='" + login_id + "'";
                const queryresult = await db.executequery(query);
                logger.info('log of login api update user last_login_date query result', queryresult);

                // console.log("queryresult", queryresult);
                if (queryresult) {
                    res.send({
                        status: true,
                        data: [{
                            message: "Vaild User",
                            loginStatus: "0",
                            logindata: {
                                user_id: login_id,
                                user_name: result[0].first_name + " " + result[0].last_name,
                                last_loginDate: result[0].last_login_date,
                                role: rol_des
                            },
                            exception: {
                                errorid: "",
                                errormessage: "No Errors"
                            },
                            jwttoken: createdtoken
                        }],
                        error: ""

                    })

                } else {
                    res.send({
                        status: false,
                        data: [{
                            message: "Invaild User",
                            loginStatus: "1",
                            logindata: {
                                user_id: "",
                                user_name: "",
                                last_loginDate: ""
                            },
                            exception: {
                                errorid: "",
                                errormessage: "No Errors"
                            }
                        }]

                    })

                }
            }
        }
        catch (err) {
            console.log(err)
            res.send({
                status: true,
                data: [],
                 error:err
            })
        }
    } else {
        res.send(validationResp)
    }

}

module.exports.signupuser = async (req, res) => {
    const validationResp = await validation.signupCheck(req);
    const createdate = new Date();
    console.log("Before if condition");
    if (validationResp.status) {

        console.log("After if condition")
        try {
            const query = "select login_id, user_id from user_master where login_id= '" + req.body.login_id + "'";
            const queryresult = await db.executequery(query);
            console.log("queryresult", queryresult);
            if (queryresult.length > 0) {
                res.send({
                    message: "User Already Created.",
                    SingupStatus: "1",
                    exception: {
                        errorid: "",
                        errormessage: "No Errors"
                    }

                })
            } else {
                console.log("create new user");
                const query1 = "INSERT INTO user_master(login_id,customer_id,password,first_name,last_name,email,mobile_number,created_by,created_on,last_login_date)" +
                    " VALUES(?,?,?,?,?,?,?,?,?,?)";
                const values = [req.body.login_id, req.body.customer_id, req.body.password, req.body.first_name, req.body.last_name, req.body.email, req.body.mobile_number, req.body.login_id, createdate, createdate]
                const res1 = await db.executevaluesquery(query1, values);
                console.log("res1", res1);
                if (res1) {
                    const createdtoken = await createToken.createToken(req.body.login_id);

                    res.send({
                        message: "User Created Successfully ",
                        SingupStatus: "0",
                        exception: {
                            errorid: "",
                            errormessage: "No Errors"
                        },
                        jwttoken: createdtoken

                    })
                } else {
                    res.send({
                        message: "",
                        createStatus: "1",
                        exception: {
                            errorid: "404",
                            errormessage: "Bad request"
                        }
                    })
                }

            }


        } catch (err) {
            console.log(err)
            res.send({
                status: true, data: []
            })
        }
    } else {
        res.send(validationResp)
    }

}

module.exports.userrolemap = async (req, res) => {
    const validationResp = await validation.userrolemapcheck(req);
    const createdate = new Date();
    if (validationResp.status) {
        try {
            const query = "select user_id,login_id from user_master where login_id='" + req.body.login_id + "'";
            const result = await db.executequery(query);
            if (result.length == '0') {
                res.send({
                    message: "Invaild User.Please enter valid login creditional!",
                    userrolemapStatus: "1",
                    exception: {
                        errorid: "",
                        errormessage: "No Errors"
                    }
                })
            }
            else {
                console.log("valid user", result);
                var login_id, user_id;
                login_id = result[0].login_id;
                console.log("login_id::", login_id);
                user_id = result[0].user_id;
                console.log("user_id::", user_id);



                const query1 = "INSERT INTO user_mapping(user_master_id,user_role_id,created_by,created_on)" +
                    " VALUES(?,?,?,?)";
                const values = [user_id, req.body.user_role_id, req.body.login_id, createdate]
                const res2 = await db.executevaluesquery(query1, values);
                console.log("res2", res2);
                if (res2) {

                    res.send({
                        message: "User Role mapped Successfully. ",
                        SingupStatus: "0",
                        exception: {
                            errorid: "",
                            errormessage: "No Errors"
                        }
                    })
                } else {
                    res.send({
                        message: "",
                        createStatus: "1",
                        exception: {
                            errorid: "404",
                            errormessage: "Bad request"
                        }
                    })
                }

            }

        }
        catch (err) {
            console.log(err)
            res.send({
                status: true, data: []
            })
        }
    } else {
        res.send(validationResp)
    }

}







