const express = require('express');
const router = express.Router();
const bodyParser = require('body-parser');
const loginController = require("../controllers/loginController");
const dvrController =require("../controllers/dvrReportController");
const auth = require("../middlewares/authorize");


router.use(bodyParser.urlencoded({ extended: true }))
router.use(bodyParser.json());

router.post("/signupuser", loginController.signupuser);
router.post("/loginuser", loginController.loginUser);
router.get("/getselectionData",auth,dvrController.getselectionData);


router.post("/createContactEntry",auth,dvrController.createContactEntry);


router.get("/getdvrdetails",auth,dvrController.getdvrDetails);
router.get("/getdashboarddetails",auth,dvrController.getdashboarddetails);

router.post("/createDvrEntry",auth,dvrController.createDvrEntry);
router.put("/updateDvrEntry",auth,dvrController.updatedvrDetails);

router.post("/userrolemap",auth ,loginController.userrolemap);

router.post("/createCustomerEntry",auth,dvrController.createCustomerentry);

router.put("/updateContactDetails",auth,dvrController.updateContactDetails);
router.put("/updateCustomerDetails",auth,dvrController.updateCustomerDetails);
router.get("/getlastestdvr",auth,dvrController.getlastestdvr);

router.get("/getcontactdetails",auth,dvrController.getcontactDetails);

router.get("/getsalepersonlist",auth,dvrController.getsalePersonList);

router.get("/getcustcontactdetails",auth,dvrController.getCustcontactDetails);
router.post("/createUpdateCustomerentry",auth,dvrController.createUpdateCustomerentry);

router.post("/deletedvrEntry",auth,dvrController.deletedvrEntry);




module.exports = router;
